package cz.punga.soutez.ai;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;
import java.util.Stack;

public class Board {
	public Jewel[][] f;
	public Stack<Jewel>[] l;
	public int[] s;
	public Board(String filename){
		f = new Jewel[][]{new Jewel[8],new Jewel[8],new Jewel[8],new Jewel[8],new Jewel[8],new Jewel[8],new Jewel[8],new Jewel[8]};
		l = new JewelStack[]{new JewelStack(),new JewelStack(),new JewelStack(),new JewelStack(),new JewelStack(),new JewelStack(),new JewelStack(),new JewelStack()};
		s = new int[8];
		try (BufferedReader br = new BufferedReader(new FileReader(new File(filename)))) {
		    String line;
		    int i=-1;
		    line = br.readLine();
		    while ((line = br.readLine()) != null) {
		       if(i++<8){
		    	   for(int j=0;j<line.length();j++){
		    		   char c = line.charAt(j);
		    		   if(j<8)
		    			   f[i][j]=Jewel.getJewelById(((int)c)-0x30);
		    	   }
		       }
		    }
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	@Override
	public String toString() {
		String a="[";
		for(Jewel[] j : f)
			a += Arrays.toString(j)+("\r\n");
		a+="]";
		return "Board [f=" + a + ", l=" + Arrays.toString(l) + "]";
	}
	public List<Sled> getUniqueAvailableSleds(){
		ArrayList<Sled> ls = new ArrayList<Sled>();
		LinkedList<Jewel> jl;
		for(int y=0;y<8;y++){
			jl = new LinkedList<Jewel>();
			sec: for(int x=0;x<8;x++){
				for(Jewel j:jl)
					if(j!=f[y][x]){
						jl.clear();
						continue sec;
						}
				jl.add(f[y][x]);
				if(jl.size()==3){
					ls.add(new Sled(new Int2Vector(x,y),new Int2Vector(x-2,y)));
				}
			}
		}
		for(int x=0;x<8;x++){
			jl = new LinkedList<Jewel>();
			sec: for(int y=0;y<8;y++){
				for(Jewel j:jl)
					if(j!=f[y][x]){
						jl.clear();
						continue sec;
						}
				jl.add(f[y][x]);
				if(jl.size()==3){
					ls.add(new Sled(new Int2Vector(x,y),new Int2Vector(x,y-2)));
				}
			}
		}
		return ls;
	}
	public Jewel[][] getBoard(){
		return f;
	}
	public Jewel[][] getDataCopy(){
		Jewel[][] r = new Jewel[][]{new Jewel[8],new Jewel[8],new Jewel[8],new Jewel[8],new Jewel[8],new Jewel[8],new Jewel[8],new Jewel[8]};
		for(int x=0;x<8;x++)
			for(int y=0;y<8;y++)
				r[y][x]=f[y][x];
		return r;
	}
	public Stack<Jewel>[] getLoadCopy(){
		Stack<Jewel>[] r = new JewelStack[]{new JewelStack(),new JewelStack(),new JewelStack(),new JewelStack(),new JewelStack(),new JewelStack(),new JewelStack(),new JewelStack()};
		for(int i=0;i<l.length;i++)
			for(Jewel j : l[i])
				r[i].add(j);
		return l;
	}
	public Board switchJewels(Int2Vector iv,Int2Vector iv2){
		Jewel[][] d = getDataCopy();
		Jewel j = d[iv.y][iv.x];
		d[iv.y][iv.x]=d[iv2.y][iv2.x];
		d[iv2.y][iv2.x]=j;
		Board b = copy(d);
		return b;
	}
	public Board(Jewel[][] f,Stack<Jewel>[] l, int[] s){
		this.f=f;
		this.l=l;
		this.s=s;
	}
	public Board copy(Jewel[][] d){
		return new Board(d,getLoadCopy(),Arrays.copyOf(s,s.length));
	}
	public void clearSleds(){
		List<Sled> ls = this.getUniqueAvailableSleds();
		int r = ls.size();
		for(Sled s : ls){
			Int2Vector a = s.getA();
			Int2Vector b = s.getB();
			for(int x=a.getX();x<=b.getX();x++)
				for(int y=a.getY();y<=b.getY();y++)
					f[y][x]=null;
		}
		Main.score+=3;
	}
	public Board drop(){
		Jewel[][] f= getDataCopy();
		int ch;
		do{
			ch=0;
			for(int x=0;x<8;x++)
				for(int y=0;y<8;y++)
					if(y<7&&f[y+1][x]==null){
						ch++;
						f[y+1][x]=f[y][x];
						f[y][x]=null;
					}
		}while(ch!=0);
		return copy(f);
	}
	public void fill(){
		for(int x=7;x>=0;x--)
			for(int y=7;y>=0;y--)
				if(f[y][x]==null)
					f[y][x]=l[y].get(s[y]++%l[y].size());
	}
	public Board clearDropAndFill(){
		Board b = copy(f);
		b.clearSleds();
		b=b.drop();
		b.fill();
		System.out.println(b.getUniqueAvailableSleds());
		if(b.getUniqueAvailableSleds().size()>0)
			return b.clearDropAndFill();
		return b;
	}
	public Move findWorkingMove(){
		for(int x1=0;x1<8;x1++)
			for(int y1=0;y1<8;y1++)
				for(int x2=0;x2<8;x2++)
					for(int y2=0;y2<8;y2++)
						if(new Int2Vector(x1, y1).getVectorsBetween(new Int2Vector(x2, y2)).size()==2)
							if(this.switchJewels(new Int2Vector(x1, y1), new Int2Vector(x2, y2)).getUniqueAvailableSleds().size()>0)
								return new Move(new Int2Vector(x1+1, y1+1), new Int2Vector(x2+1, y2+1));
		return null;
	}
}

